Attribute VB_Name = "mdlDate"
Option Explicit

'Code by Mojtaba Malaekeh (MMZ)

Public Sub ShamsiToMiladi(ByVal IYear, ByVal IMonth, ByVal IDay, OYear, OMonth, ODay)
    Dim Limit, MaxDay, CriticalDay As Integer
    Dim LY As Boolean 'Leap Year
    Dim AL As Boolean '2 Years After Leap
    Dim TT As Boolean 'Two or Three
    LY = IYear Mod 4 = 3
    AL = IYear Mod 4 = 2
    TT = IYear Mod 4 = 2 Or IYear Mod 4 = 3
    Select Case IMonth
        Case 1:  Limit = IIf(LY, 12, 11): MaxDay = 31
        Case 2:  Limit = IIf(LY, 11, 10): MaxDay = 30
        Case 3:  Limit = IIf(LY, 11, 10): MaxDay = 31
        Case 4:  Limit = IIf(LY, 10, 9):  MaxDay = 30
        Case 5:  Limit = IIf(LY, 10, 9):  MaxDay = 31
        Case 6:  Limit = IIf(LY, 10, 9):  MaxDay = 31
        Case 7:  Limit = IIf(LY, 9, 8):   MaxDay = 30
        Case 8:  Limit = IIf(LY, 10, 9):  MaxDay = 31
        Case 9:  Limit = IIf(LY, 10, 9):  MaxDay = 30
        Case 10: Limit = IIf(LY, 11, 10): MaxDay = 31
        Case 11: Limit = IIf(LY, 12, 11): MaxDay = 31
        Case 12: Limit = IIf(TT, 10, 9):  MaxDay = IIf(AL, 29, 28)
    End Select
    CriticalDay = IIf(LY, 11, 10)
    ODay = IIf(IDay <= Limit, IDay - Limit + MaxDay, IDay - Limit)
    OMonth = IIf(IDay <= Limit, IMonth + 2, IMonth + 3)
    If OMonth > 12 Then OMonth = OMonth - 12
    OYear = IYear + IIf((IMonth < 10) Or (IMonth = 10 And IDay <= CriticalDay), 621, 622)
End Sub

Public Sub MiladiToShamsi(ByVal IYear, ByVal IMonth, ByVal IDay, OYear, OMonth, ODay)
    Dim y, Limit, MaxDay, CriticalDay As Integer
    y = Abs(IYear - 5) Mod 4
    Select Case IMonth
        Case 1:  Limit = IIf(y = 0, 19, 20): MaxDay = 30
        Case 2:  Limit = IIf(y = 0, 18, 19): MaxDay = 30
        Case 3:  Limit = IIf(y = 3, 19, 20): MaxDay = IIf(y = 0, 30, 29)
        Case 4:  Limit = IIf(y = 3, 19, 20): MaxDay = 31
        Case 5:  Limit = IIf(y = 3, 20, 21): MaxDay = 31
        Case 6:  Limit = IIf(y = 3, 20, 21): MaxDay = 31
        Case 7:  Limit = IIf(y = 3, 21, 22): MaxDay = 31
        Case 8:  Limit = IIf(y = 3, 21, 22): MaxDay = 31
        Case 9:  Limit = IIf(y = 3, 21, 22): MaxDay = 31
        Case 10: Limit = IIf(y = 3, 21, 22): MaxDay = 30
        Case 11: Limit = IIf(y = 3, 20, 21): MaxDay = 30
        Case 12: Limit = IIf(y = 3, 20, 21): MaxDay = 30
    End Select
    CriticalDay = IIf(y = 3, 19, 20)
    ODay = IIf(IDay <= Limit, IDay - Limit + MaxDay, IDay - Limit)
    OMonth = IIf(IDay <= Limit, IMonth + 9, IMonth + 10)
    If OMonth > 12 Then OMonth = OMonth - 12
    OYear = IYear - IIf((IMonth < 3) Or (IMonth = 3 And IDay <= CriticalDay), 622, 621)
End Sub
